/* This file is part of IRadit.
   Copyright 2014, Victor Algaba <victor@radit.org> www.radit.org

   IRadit is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Iradit is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Clementine.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <QDrag>
#include <QMenu>
#include <QDebug>
#include <QContextMenuEvent>
#include "button/Button.h"
#include "mimedata/MimeData.h"





Button::Button(QWidget *parent): QPushButton(parent)
{





      this->setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Expanding);
  //  this->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Expanding);
    this->setText(" Nombre del fichero\n"
                  "\n"
                  "00:00:00");



    this->setCursor(QCursor(Qt::PointingHandCursor));
    this->setAcceptDrops(true);




}



void Button::mousePressEvent(QMouseEvent *event){
QList<QUrl> Url;

    if (event->button() == Qt::LeftButton){

             //  Url <<this->url;


             QDrag *drag = new QDrag(this);
             QMimeData *mimeData = new QMimeData;


             mimeData->setText(this->url.toString());
             //mimeData->setButton(this);
          // mimeData->setUrls(Url);

           drag->setMimeData(mimeData);
            // drag->setPixmap(iconPixmap);



           drag->exec(Qt::MoveAction);

             // this->url="";
             // this->setText("");



             // delete drag;
             // delete mimeData;


    }

}


void Button::dragEnterEvent(QDragEnterEvent *event){

    if (event->mimeData()->hasFormat("text/uri-list"))
    event->acceptProposedAction();

    if (event->mimeData()->hasFormat("text/plain"))
    event->acceptProposedAction();


}



void Button::dropEvent(QDropEvent *event){


    Button* source = qobject_cast<Button*>(event->source());

    QList<QUrl> urls = event->mimeData()->urls();
    if (!urls.isEmpty()){
         url=urls.first().toLocalFile();
         setInfo(urls.first().toLocalFile());
        return;
    }




    if(source==this)
       return;




        url=event->mimeData()->text();

        if(url.isEmpty())
           return;






       setInfo(event->mimeData()->text());

        source->url="";
        source->setText("");
        source->setText(source->numero);



}



void Button::setInfo(QFileInfo file){


    QString L2=file.baseName().mid(13);
    this->setToolTip(file.baseName());

    this->setText(" " +file.baseName()+"\n"
             //     + L2+ "\n"
                  "\n"
                 " 00:00:00");
}


void Button::setNumero(QString num){


    this->numero=num;
}



///
void Button::setPlayer(PLAYER_TIPO tipo){



    switch(tipo) {
            case 0 :
                  this->setStyleSheet(QString::fromUtf8("QPushButton {\n"
                                                        "\n"
                                                        "background-color: qlineargradient(spread:pad, x1:0.994318, y1:1, x2:1, y2:0, stop:0.0113636 rgba(146, 169, 211, 255), stop:0.982955 rgba(174, 199, 230, 255));\n"
                                                        "border-color: rgb(0, 0, 0);\n"
                                                        "\n"
                                                        "}\n"
                                                        "\n"
                                                        "QPushButton:hover {\n"
                                                        "background-color: rgb(255, 255, 255);\n"
                                                        "\n"
                                                        "\n"
                                                        "}"));
               break;
            case 1 :
                  this->setStyleSheet(QString::fromUtf8("QPushButton {\n"
                                                        "\n"
                                                        "background-color: qlineargradient(spread:pad, x1:0.994318, y1:1, x2:1, y2:0, stop:0.00568182 rgba(209, 160, 131, 255), stop:0.0113636 rgba(138, 106, 93, 255), stop:0.982955 rgba(223, 190, 166, 255));\n"
                                                        "border-color: rgb(0, 0, 0);\n"
                                                        "\n"
                                                        "}\n"
                                                        "\n"
                                                        "QPushButton:hover {\n"
                                                        "background-color: rgb(255, 255, 255);\n"
                                                        "\n"
                                                        "\n"
                                                        "}"));
                break;
            case 2 :

                break;


    }





 }


void Button::contextMenuEvent(QContextMenuEvent *event)
 {
    QMenu *menu = new QMenu(this);


    menu->setStyleSheet(QString::fromUtf8("QMenu {\n"
                                          "\n"
                                          "background-color: qlineargradient(spread:pad, x1:0.994318, y1:1, x2:1, y2:0, stop:0.0113636 rgba(146, 169, 211, 255), stop:0.982955 rgba(174, 199, 230, 255));\n"
                                          "border-color: rgb(0, 0, 0);\n"
                                          "}\n"
                                          "QMenu::item {\n"
                                          "background-color: rgb(255, 255, 255);\n"
                                          "}\n"
                                          "QMenu::item:selected {\n"
                                          "background-color: qlineargradient(spread:pad, x1:1, y1:1, x2:1, y2:0, stop:0 rgba(129, 166, 226, 255), stop:1 rgba(93, 131, 190, 255));\n"
                                          "}"));




     // QIcon *icono;
     // QAction *Act;



   /* openAct = new QAction(QIcon(":/images/open.png"), tr("&Open..."), this);
         openAct->setShortcuts(QKeySequence::Open);
         openAct->setStatusTip(tr("Open an existing file"));
         connect(openAct, SIGNAL(triggered()), this, SLOT(open()));

         fileMenu->addAction(openAct);*/



    menu->addAction(new QAction("Preasignar reproductor",this));
       //  menu->addAction(actionAbrir);
       //  menu->addAction(actionGuardar);
        // menu->addSeparator();//separador



  menu->exec(event->globalPos());

delete menu;

}








